<?php
require_once __DIR__ . '/../vendor/autoload.php';
use App\GameClient;

class ProgramMain {
    private static ?GameClient $client = null;
    
    private static function getClient(): GameClient {
        if (self::$client === null) {
            self::$client = new GameClient();
        }
        return self::$client;
    }

    public static function runInteractiveCli(): void {
        $client = self::getClient();
        
        // 设置信号处理
        // pcntl_async_signals(true);
        // pcntl_signal(SIGINT, function() use ($client) {
        //     $client->close();
        //     exit(0);
        // });

         // 设置非阻塞标准输入
        stream_set_blocking(STDIN, false);

        echo "游戏客户端交互模式（输入命令执行，如 login, outGame, exit,getFriends\n";
        
        while (true) {
            $input = readline("> ");
            $args = explode(' ', $input);
            
            switch ($args[0]) {
                case 'login':
                    if (count($args) < 3) {
                        echo "用法: login [账号] [密码]\n";
                        break;
                    }
                    $client->login($args[1], $args[2]);
                    break;
                case 'outGame':
                    $client->outGame();
                    break;
                case 'getFriends':
                    $client->getFriends();
                    break;
                case 'exit':
                    $client->close();
                    exit(0);
                default:
                    echo "未知命令。可用命令: login, outGame,getFriends, exit\n";
            }
        }
    }
}

// 直接进入交互模式
ProgramMain::runInteractiveCli();